Package com.io7m.idstore.server.api

# Record Class IdServerConfiguration

java.lang.Object
java.lang.Record
com.io7m.idstore.server.api.IdServerConfiguration

Record Components:
  `adminApiAddress` - The admin API address
  `branding` - The branding configuration
  `clock` - The clock
  `databaseConfiguration` - The database configuration for the server
  `databases` - The factory of databases that will be used for the server
  `history` - The history configuration
  `locale` - The locale
  `mailConfiguration` - The mail server configuration
  `openTelemetry` - The OpenTelemetry configuration
  `rateLimit` - The rate limiting configuration
  `passwordExpiration` - The password expiration configuration
  `sessions` - The session configuration
  `userApiAddress` - The user API address
  `userViewAddress` - The user view address

public record IdServerConfiguration(Locale locale, Clock clock, IdDatabaseFactoryType databases, IdDatabaseConfiguration databaseConfiguration, IdServerMailConfiguration mailConfiguration, IdServerHTTPServiceConfiguration userApiAddress, IdServerHTTPServiceConfiguration userViewAddress, IdServerHTTPServiceConfiguration adminApiAddress, IdServerSessionConfiguration sessions, IdServerBrandingConfiguration branding, IdServerHistoryConfiguration history, IdServerRateLimitConfiguration rateLimit, IdServerPasswordExpirationConfiguration passwordExpiration, Optional<IdServerOpenTelemetryConfiguration> openTelemetry) extends Record
The configuration for a server.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `IdServerConfiguration(Locale locale, Clock clock, IdDatabaseFactoryType databases, IdDatabaseConfiguration databaseConfiguration, IdServerMailConfiguration mailConfiguration, IdServerHTTPServiceConfiguration userApiAddress, IdServerHTTPServiceConfiguration userViewAddress, IdServerHTTPServiceConfiguration adminApiAddress, IdServerSessionConfiguration sessions, IdServerBrandingConfiguration branding, IdServerHistoryConfiguration history, IdServerRateLimitConfiguration rateLimit, IdServerPasswordExpirationConfiguration passwordExpiration, Optional<IdServerOpenTelemetryConfiguration> openTelemetry)`
  The configuration for a server.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `IdServerHTTPServiceConfiguration`
  `adminApiAddress()`
  Returns the value of the `adminApiAddress` record component.
  `IdServerBrandingConfiguration`
  `branding()`
  Returns the value of the `branding` record component.
  `Clock`
  `clock()`
  Returns the value of the `clock` record component.
  `IdDatabaseConfiguration`
  `databaseConfiguration()`
  Returns the value of the `databaseConfiguration` record component.
  `IdDatabaseFactoryType`
  `databases()`
  Returns the value of the `databases` record component.
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `IdServerHistoryConfiguration`
  `history()`
  Returns the value of the `history` record component.
  `Locale`
  `locale()`
  Returns the value of the `locale` record component.
  `IdServerMailConfiguration`
  `mailConfiguration()`
  Returns the value of the `mailConfiguration` record component.
  `OffsetDateTime`
  `now()`
  `Optional<IdServerOpenTelemetryConfiguration>`
  `openTelemetry()`
  Returns the value of the `openTelemetry` record component.
  `IdServerPasswordExpirationConfiguration`
  `passwordExpiration()`
  Returns the value of the `passwordExpiration` record component.
  `IdServerRateLimitConfiguration`
  `rateLimit()`
  Returns the value of the `rateLimit` record component.
  `IdServerSessionConfiguration`
  `sessions()`
  Returns the value of the `sessions` record component.
  `final String`
  `toString()`
  Returns a string representation of this record class.
  `IdServerHTTPServiceConfiguration`
  `userApiAddress()`
  Returns the value of the `userApiAddress` record component.
  `IdServerHTTPServiceConfiguration`
  `userViewAddress()`
  Returns the value of the `userViewAddress` record component.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### IdServerConfiguration

    public IdServerConfiguration(Locale locale, Clock clock, IdDatabaseFactoryType databases, IdDatabaseConfiguration databaseConfiguration, IdServerMailConfiguration mailConfiguration, IdServerHTTPServiceConfiguration userApiAddress, IdServerHTTPServiceConfiguration userViewAddress, IdServerHTTPServiceConfiguration adminApiAddress, IdServerSessionConfiguration sessions, IdServerBrandingConfiguration branding, IdServerHistoryConfiguration history, IdServerRateLimitConfiguration rateLimit, IdServerPasswordExpirationConfiguration passwordExpiration, Optional<IdServerOpenTelemetryConfiguration> openTelemetry)
    The configuration for a server.
    Parameters:
      `adminApiAddress` - The admin API address
      `branding` - The branding configuration
      `clock` - The clock
      `databaseConfiguration` - The database configuration for the server
      `databases` - The factory of databases that will be used for the server
      `history` - The history configuration
      `locale` - The locale
      `mailConfiguration` - The mail server configuration
      `openTelemetry` - The OpenTelemetry configuration
      `rateLimit` - The rate limiting configuration
      `passwordExpiration` - The password expiration configuration
      `sessions` - The session configuration
      `userApiAddress` - The user API address
      `userViewAddress` - The user view address

- ## Method Details

  - ### now

    public OffsetDateTime now()
    Returns:
      The current time based on the configuration's clock

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. All components in this record class are compared with `Objects::equals(Object,Object)`.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### locale

    public Locale locale()
    Returns the value of the `locale` record component.
    Returns:
      the value of the `locale` record component

  - ### clock

    public Clock clock()
    Returns the value of the `clock` record component.
    Returns:
      the value of the `clock` record component

  - ### databases

    public IdDatabaseFactoryType databases()
    Returns the value of the `databases` record component.
    Returns:
      the value of the `databases` record component

  - ### databaseConfiguration

    public IdDatabaseConfiguration databaseConfiguration()
    Returns the value of the `databaseConfiguration` record component.
    Returns:
      the value of the `databaseConfiguration` record component

  - ### mailConfiguration

    public IdServerMailConfiguration mailConfiguration()
    Returns the value of the `mailConfiguration` record component.
    Returns:
      the value of the `mailConfiguration` record component

  - ### userApiAddress

    public IdServerHTTPServiceConfiguration userApiAddress()
    Returns the value of the `userApiAddress` record component.
    Returns:
      the value of the `userApiAddress` record component

  - ### userViewAddress

    public IdServerHTTPServiceConfiguration userViewAddress()
    Returns the value of the `userViewAddress` record component.
    Returns:
      the value of the `userViewAddress` record component

  - ### adminApiAddress

    public IdServerHTTPServiceConfiguration adminApiAddress()
    Returns the value of the `adminApiAddress` record component.
    Returns:
      the value of the `adminApiAddress` record component

  - ### sessions

    public IdServerSessionConfiguration sessions()
    Returns the value of the `sessions` record component.
    Returns:
      the value of the `sessions` record component

  - ### branding

    public IdServerBrandingConfiguration branding()
    Returns the value of the `branding` record component.
    Returns:
      the value of the `branding` record component

  - ### history

    public IdServerHistoryConfiguration history()
    Returns the value of the `history` record component.
    Returns:
      the value of the `history` record component

  - ### rateLimit

    public IdServerRateLimitConfiguration rateLimit()
    Returns the value of the `rateLimit` record component.
    Returns:
      the value of the `rateLimit` record component

  - ### passwordExpiration

    public IdServerPasswordExpirationConfiguration passwordExpiration()
    Returns the value of the `passwordExpiration` record component.
    Returns:
      the value of the `passwordExpiration` record component

  - ### openTelemetry

    public Optional<IdServerOpenTelemetryConfiguration> openTelemetry()
    Returns the value of the `openTelemetry` record component.
    Returns:
      the value of the `openTelemetry` record component